Description

After merging the CommonMark patch #32424, Redmine will contain an HTML::Pipeline implementation limited to this new format. It

makes then perfect sense to extend the new concept to text formatting generally.

The current implementation looks like:

 Text_Formatting-Redmine-4.2.png 

While the new Markdown (CommonMark) implementation is designed like:

 CommonMark-HTML_Pipeline.png 

Migrating text rendering to HTML::Pipeline should provide several benefits:

Better separation of concerns.

Cleaner, safer and DRY code.

Individual formatters can be freed from excessive restrictions that were introduced as XSS prevention. Especially the absolute

prohibition of HTML tags can be pain in specific cases.

More consistent behavior among formatters (e.g. HTML is currently escaped in Textile, but dropped in Markdown),

Controlled level of security without the need to rely on individual formatter implementations that often use poorly maintained

libraries.

More flexibility for Redmine developers and Redmine plugin developers. Adding some hooks would be nice and would allow e.g.

implementing mermaid charts as a custom syntax highlighter - in the same way as GitLab.

Some inspiration can be found in GitLab sources, but our pipelines would probably won't need to go that complex.

If there were no other timing considerations, it would make sense to implement this together with Redcarpet removal.

Related issues:

Related to Redmine - Feature #32424: CommonMark Markdown Text Formatting Closed

History

#1 - 2021-04-12 04:31 - Jens Krämer

Totally agree, the potential benefits of switching to html pipeline are quite big. This kind of modularization will allow for many interesting features to be

implemented in core or by plugins in the future.

As stated in #32424-37, I'd even like to move the redcarpet renderer to the pipeline, so it could still be used in the future as part of core, or extracted

into a plugin, by those unwilling or unable to switch to common mark.

#2 - 2021-08-15 12:46 - Marius BĂLTEANU

- Related to Feature #32424: CommonMark Markdown Text Formatting added

#3 - 2021-08-15 12:49 - Marius BĂLTEANU

- Target version set to Candidate for next major release

I'm setting this to Candidate for next major release because for sure it is something that we should work on. If you have any working code to start

from it, it's welcome.
